unit Main;

interface

uses
  Windows, Forms, SysUtils, StdCtrls, Controls, Classes, Registry, ShellAPI,
  ShFolder;

type
  TMainForm = class(TForm)
    lbl_info: TLabel;
    btn_no: TButton;
    btn_uninstall: TButton;
    btn_ok: TButton;
    procedure btn_ok_click(Sender: TObject);
    procedure btn_uninstall_click(Sender: TObject);
    procedure form_show(Sender: TObject);
    procedure form_close(Sender: TObject; var Action: TCloseAction);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

// http://entwickler-forum.de/archive/index.php/t-38484.html
function GetShellFolder(const CSIDL: Integer): string;
var
  pszPath: {$IFDEF DotNet}
  StringBuilder
  {$ELSE}
  PAnsiChar
  {$ENDIF};
begin
  {$IFDEF DotNet}
  pszPath := StringBuilder.Create(MAX_PATH);
  {$ELSE}
  pszPath := AllocMem(MAX_PATH);
  {$ENDIF}
  try
    if Succeeded(SHGetFolderPath(0, CSIDL, 0, 0, pszPath)) then
      Result := pszPath;
  finally
    {$IFNDEF DotNet}
    FreeMem(pszPath);
    {$ENDIF}
  end;

  // Addition
  result := IncludeTrailingPathDelimiter(result);
end;

procedure VerzeichnisLoeschen(directory: string);
var
  fos: TSHFileOpStruct;
begin
  ZeroMemory(@fos, SizeOf(fos));
  with fos do begin
    wFunc := FO_DELETE;
    fFlags := FOF_SILENT or FOF_NOCONFIRMATION;
    pFrom := PChar(directory+#0);
  end;
  if (SHFileOperation(fos)<>0) then
    MessageBox(0, 'Fehler beim Lschen', nil, MB_ICONERROR);
end;

procedure TMainForm.btn_ok_click(Sender: TObject);
begin
  close;
end;

procedure DelFilesInDir(ADirectory: string; AMask: String; ARekursiv: Boolean);
var
  SR: TSearchRec;
begin
  if (ADirectory <> '') and (ADirectory[length(ADirectory)] <> '\') then
  ADirectory := ADirectory + '\';

  if (FindFirst(ADirectory+AMask,faAnyFile-faDirectory,SR)=0) then
  begin
    repeat
      if (SR.Name<>'.') and (SR.Name<>'..') and (SR.Attr<>faDirectory) then
        deletefile(ADirectory+SR.Name)
    until FindNext(SR)<>0;
    FindClose(SR);
  end;

  if ARekursiv then
    if (FindFirst(ADirectory+'*.*',faDirectory,SR)=0) then
    begin
      repeat
        if (SR.Name<>'.') and (SR.Name<>'..') then
          DelFilesInDir(ADirectory+SR.Name,AMask,True);
      until FindNext(SR)<>0;
      FindClose(SR);
    end;

  removedir(ADirectory);
end;

procedure TMainForm.btn_uninstall_click(Sender: TObject);
var
  reg: tregistry;
  tmp: string;
begin
  btn_no.Enabled := not btn_no.enabled;
  btn_uninstall.Enabled := not btn_uninstall.enabled;

  deletefile(GetShellFolder(CSIDL_SYSTEM) + 'bdeadmin.cpl');
  reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('Software\Borland\Database Engine', false) then
    begin
      deletefile(Reg.ReadString('CONFIGFILE01')); // mehrere?
      tmp := Reg.ReadString('DLLPath');
      if DirectoryExists(tmp) then DelFilesInDir(tmp, '*', true);
      reg.CloseKey;
    end;
    reg.DeleteKey('Software\Borland\Database Engine');
    reg.DeleteKey('Software\Microsoft\Windows\CurrentVersion\Uninstall\Borland Database Engine');
  finally
    reg.Free;
  end;
  lbl_info.Caption := 'Borland Database Engine wurde erfolgreich von Ihrem System entfernt.' + #13#13 + 'Sie knnen nun keine BDE-Basierenden Datenbankanwendungen' + #13 + 'mehr nutzen. Sie knnen jedoch zu einem spteren Zeitpunkt BDE' + #13 + 'wieder von www.viathinksoft.de beziehen.';
  btn_no.visible := not btn_no.visible;
  btn_uninstall.visible := not btn_uninstall.visible;
  btn_ok.visible := not btn_ok.visible;
end;

procedure TMainForm.form_show(Sender: TObject);
begin
  lbl_info.Caption := 'Mchten Sie Borland Database Engine wirklich vom System entfernen?' + #13#13 + 'Sie haben danach nicht mehr die Mglichkeit, bestimmte Datenbank-' + #13 + 'anwendungen zu nutzen. Die Deinstallation wird daher nicht empfohlen.';
end;

procedure TMainForm.form_close(Sender: TObject; var Action: TCloseAction);
begin
  if btn_ok.visible and fileexists(IncludeTrailingPathDelimiter(extractfiledir(ParamStr(0)))+'delbdeuninstall.bat') then
    shellexecute(handle, 'open', pchar(IncludeTrailingPathDelimiter(extractfiledir(ParamStr(0)))+'DelBDEUninstall.bat'), nil, pchar(IncludeTrailingPathDelimiter(extractfiledir(ParamStr(0)))), SW_HIDE);
end;

end.

